var sharenameList = [];
var UserAccount_NameDirMap_cw = [];
var UserAccount_DirNameMap_cw = [];
var UserAccount_UnasApps_cw = [];
var belonggroup = 'Administrators';
(function() {
  jQuery('#useraccount_adduser_username').keyup(function() {
    usernameOK = false;
    jQuery('#useraccount_adduser_username').attr('class', 'unas_input');
    jQuery("#useraccount_adduser_username_warning").text('');
    jQuery("#useraccount_adduser_username_warning_icon").attr('class', '');
    jQuery("#useraccount_adduser_username_warning_icon").attr('title', '');
    disableSubmit();

    checkUsername();
    updateSubmitBtn();
  });
  jQuery('#useraccount_adduser_password').keyup(function() {
    passwordOK = false;
    jQuery('#useraccount_adduser_password').attr('class', 'unas_input');
    jQuery("#useraccount_adduser_password_warning").text('');
    jQuery('#useraccount_adduser_repassword').attr('class', 'unas_input');
    jQuery("#useraccount_adduser_repassword_warning").attr('class', "");
    jQuery("#useraccount_adduser_repassword_warning").attr('title', "");
    disableSubmit();

    jQuery('#useraccount_adduser_password').val(jQuery('#useraccount_adduser_password').val().replace(/\s+/g, ''));
    checkPassword();
    updateSubmitBtn();
  });
  jQuery('#useraccount_adduser_repassword').keyup(function() {
    passwordOK = false;
    jQuery('#useraccount_adduser_repassword').attr('class', 'unas_input');
    jQuery("#useraccount_adduser_repassword_warning").attr('class', "");
    jQuery("#useraccount_adduser_repassword_warning").attr('title', "");
    disableSubmit();

    jQuery('#useraccount_adduser_repassword').val(jQuery('#useraccount_adduser_repassword').val().replace(/\s+/g, ''));
    checkPassword();
    updateSubmitBtn();
  });
  jQuery('#useraccount_adduser_description').keyup(function() {});
})();

function accountAddUserShowWaiting() {
  jQuery('#useraccount_adduser_waiting_content').attr("style", "display:block");
  jQuery('#useraccount_adduser_waiting_logo').attr("style", "display:block");
}

function accountAddUserHideWaiting() {
  jQuery('#useraccount_adduser_waiting_content').attr("style", "display:none");
  jQuery('#useraccount_adduser_waiting_logo').attr("style", "display:none");
}


function checkPassword() {
  var password = jQuery('#useraccount_adduser_password').val();
  var repassword = jQuery('#useraccount_adduser_repassword').val();

  if (password.length > 32) {
    jQuery('#useraccount_adduser_password').attr('class', 'unas_input_error');
    jQuery("#useraccount_adduser_password_warning").text(UNAS._('The limit is 32 characters'));
    return;
  }
  if (repassword === '') {
    return;
  }
  if (password !== repassword) {
    jQuery('#useraccount_adduser_repassword').attr('class', 'unas_input_error');
    jQuery("#useraccount_adduser_repassword_warning").attr('class', "unas_icon_error");
    jQuery("#useraccount_adduser_repassword_warning").attr('title', UNAS._('The two passwords are not consistent with each other!'));
  } else {
    passwordOK = true;
  }
}

function checkUsername() {
  var username = jQuery.trim(jQuery('#useraccount_adduser_username').val());
  if (username.length == 0) {
    return;
  }
  var reg = /^[a-z_][a-z0-9_]{0,31}$/;
  if (username.length > 32) {
    jQuery('#useraccount_adduser_username').attr('class', 'unas_input_error');
    jQuery("#useraccount_adduser_username_warning").text(UNAS._('The limit is 32 characters'));
    return;
  }
  if (!reg.test(username)) {
    jQuery('#useraccount_adduser_username').attr('class', 'unas_input_error');
    jQuery("#useraccount_adduser_username_warning").text(UNAS._('##$@useraccount@$##A valid user name starts with a lower letter or underscore, followed by any character in [a-z0-9_], and must be no more than 32 characters.##$@useraccount@$##'));
    return;
  }
  if (sharenameList.indexOf(username) > -1) {
    jQuery('#useraccount_adduser_username').attr('class', 'unas_input_error');
    jQuery("#useraccount_adduser_username_warning_icon").attr('class', "unas_icon_error");
    jQuery("#useraccount_adduser_username_warning_icon").attr('title', UNAS._('The user name cannot be the same as the Share Name'));
    return;
  }
  jQuery.ajax({
    url: "/apps/useraccount/includes/services_useraccount.php",
    type: "POST",
    async: true,
    timeout: 20000,
    data: {
      username: username,
      action: "isexists_username"
    },
    success: function(data) {
      if (data) {
        jQuery('#useraccount_adduser_username').attr('class', 'unas_input_error');
        jQuery("#useraccount_adduser_username_warning_icon").attr('class', "unas_icon_error");
        jQuery("#useraccount_adduser_username_warning_icon").attr('title', UNAS._('Username is already in use'));
      } else {
        usernameOK = true;
      }
      updateSubmitBtn();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      ///console.log('account_adduser isexists_username error textStatus:'+textStatus);
    }
  });
}

function doAddUser(closeWindow) {
  accountAddUserShowWaiting();

  var uid = jQuery('#useraccount_adduser_username').val();
  var pwd = jQuery('#useraccount_adduser_password').val();
  var verifypassword = jQuery('#useraccount_adduser_repassword').val();
  var description = jQuery('#useraccount_adduser_description').val();
  var group = belonggroup;

  if (pwd !== verifypassword) {
    alert(UNAS._("The two passwords are not consistent with each other!"));
    return false;
  }

  jQuery.ajax({
    url: "/desktop/includes/login.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      action: "get_public_key"
    }),
    success: function(result) {
      var encrypt = new JSEncrypt();
      encrypt.setPublicKey(result);
      // pwd = encrypt.encrypt(JSON.stringify(pwd));
      pwd = encrypt.encrypt(pwd);
      //pwd = encodeURI(pwd).replace(/\+/g, '%2B');
      var desktopunitstate = GetUserDesktopUnitState();
      var desktopunitstate = GetUserDesktopUnitState();
      var sudo = jQuery('#useraccount_edit_info_sudo').prop("checked") ? 1 : 0;
      var webaccess = jQuery('#useraccount_edit_info_Webcheck').prop("checked") ? 1 : 0;

      jQuery.ajax({
        url: "/apps/useraccount/includes/index.php",
        type: "POST",
        async: true,
        timeout: 30000,
        data: JSON.stringify({
          cmd: "user_create",
          token: UToken,
          params: {
            uid: uid,
            pwd: pwd,
            description: description,
            group: group,
            desktopunitstate: desktopunitstate,
            privileges: [],
            access: webaccess,
            sudoer: sudo,
          }
        }),
        dataType: 'json',
        contentType: 'json',
        success: function(data) {
          setUserAccountAppPrivilegeCw(uid);
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          accountAddUserHideWaiting();
        }
      });
    }
  });

}

function updateSubmitBtn() {
  if (usernameOK && passwordOK)
    enableSubmit();
}

function enableSubmit() {
  jQuery("#useraccount_adduser_apply").attr("class", "unas_button_sub");
  jQuery("#useraccount_adduser_enter").attr("class", "unas_button_sub");
}

function disableSubmit() {
  jQuery("#useraccount_adduser_apply").attr("class", "unas_button_sub_disabled");
  jQuery("#useraccount_adduser_enter").attr("class", "unas_button_sub_disabled");
}
//点击'确认'按钮
function addUserEnter() {
  if (jQuery("#useraccount_adduser_enter").attr("class") == "unas_button_sub_disabled")
    return false;

  doAddUser(true);
}

//点击'应用'按钮
function addUserApply() {
  if (jQuery("#useraccount_adduser_apply").attr("class") == "unas_button_sub_disabled")
    return false;

  doAddUser(false);

}

//点击'取消'按钮
function addUserCancel() {
  MUI.closeWindow(parent.document.getElementById('AddUserWindow'));
}

function GetUserDesktopUnitState() {
  var desktopInfo = {
    'language': "English",
    'theme': "default",
    'wallpaper': "/desktop/wallpapers/desktop/default.jpg",
    'fit': "",
    'shortcuts': []
  };
  var groupname = jQuery('#useraccount_adduser_belonggroup').val();
  if (groupname == 'Administrators') {
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "App ManagerDesktopShortcut",
      "x": "20px",
      "y": "40px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "Control PanelDesktopShortcut",
      "x": "20px",
      "y": "20px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "U-File ExplorerDesktopShortcut",
      "x": "20px",
      "y": "60px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "Unas HelpDesktopShortcut",
      "x": "20px",
      "y": "80px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "U-AnywhereDesktopShortcut",
      "x": "20px",
      "y": "100px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "Easy SetupDesktopShortcut",
      "x": "20px",
      "y": "120px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "TransmissionDesktopShortcut",
      "x": "20px",
      "y": "140px"
    });
  } else {
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "Control PanelDesktopShortcut",
      "x": "20px",
      "y": "20px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "Unas HelpDesktopShortcut",
      "x": "20px",
      "y": "110px"
    });
    desktopInfo.shortcuts.push({
      "vd": "0",
      "id": "U-File ExplorerDesktopShortcut",
      "x": "20px",
      "y": "60px"
    });
  }
  return JSON.stringify(desktopInfo); //desktop info to be saved.
}

//下一步
function opStep(type) {
  var ev = window.event || arguments.callee.caller.arguments[0];
  ev.stopPropagation();
  var t = jQuery(ev.target);
  var index = 0;
  if (type) {
    index = +t.attr('index') + 1;
  } else {
    index = +t.attr('index') - 1;
  }

  if (index == jQuery('.jvc-steppages').length) {

    addUserEnter();
    return;
  }
  jQuery('.jvc-steppages').hide();
  jQuery('#jv-adduserpage-' + index).show();

  if (index == 2) {
    getUserAccountAppPrivilege(belonggroup == "Administrators" ? 1 : 0);
  }
}

function cwgenerateMap() {
  for (var i = 0; i < UNAS.Apps.length; i++) {
    UserAccount_UnasApps_cw.push(UNAS.Apps[i].appName);
    UserAccount_NameDirMap_cw[UNAS.Apps[i].appName] = UNAS.Apps[i].appDir;
    UserAccount_DirNameMap_cw[UNAS.Apps[i].appDir] = UNAS.Apps[i].appName;
  }
}

function getUserAccountAppPrivilege(userName) {
  jQuery('#useraccount_privilege_username').html(userName);
  //
  jQuery.ajax({
    // url: "/apps/useraccount/includes/services_useraccount.php",
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    timeout: 30000,
    // data: {
    //   userName: userName,
    //   action: "listuseraccountappprivilege"
    // },
    dataType: 'json',
    data: JSON.stringify({
      cmd : 'apprivileges_default',
      token: UToken,
      params : {
        administrators : userName
      }
    }),
    success: function(res) {
      var appsLen = UserAccount_UnasApps_cw.length;
      var data = [];
      if (res.results.records) {
        data = res.results.records || [];
      }
      if (res.results.administrators) {
        jQuery("#useraccount_app_privilege_selectall").prop("checked", true);
      } else {
        jQuery("#useraccount_app_privilege_selectall").prop("checked", false);
      }
      jQuery('#useraccount_appprivilege_applist').html('');
      for (var i = 0; i < appsLen; i++) {
        if (UserAccount_UnasApps_cw[i] == "")
          continue;
        var str = '';
        var appState = '';
        str += '<tr>';
        str += '<td style="width:10%;text-align:center;">';
        if (data.indexOf(UserAccount_NameDirMap_cw[UserAccount_UnasApps_cw[i]]) != -1 || res.results.administrators) {
          str += '<span class="unas_table_text">';
          str += '<div class="unas_checkbox"><input type="checkbox" name="useraccount_app_privilege_ugcheck" id="useraccount_app_privilege_checkbox_' + i + '" value="' + UserAccount_NameDirMap_cw[UserAccount_UnasApps_cw[i]] + '" alreadyin="1" onClick="cwcheckUserAccountAppPrivilegeSubmit()" checked/><label for="useraccount_app_privilege_checkbox_' + i + '"></label></div>';
          str += '</span>';
          appState = "Accessible";
        } else {
          str += '<span class="unas_table_text">';
          str += '<div class="unas_checkbox"><input type="checkbox" class="useraccount_privilege_ugcheck" name="useraccount_app_privilege_ugcheck" id="useraccount_app_privilege_checkbox_' + i + '" value="' + UserAccount_NameDirMap_cw[UserAccount_UnasApps_cw[i]] + '" alreadyin="0" onClick="cwcheckUserAccountAppPrivilegeSubmit()"/><label for="useraccount_app_privilege_checkbox_' + i + '"></label></div>';
          str += '</span>';
          appState = "Inaccessible";
        }
        str += '</td>';
        str += '<td width="60%" align="left" title="' + UNAS._(UserAccount_UnasApps_cw[i]) + '">';
        str += '<span class="unas_table_text">' + cwgroupCutStr(UNAS._(UserAccount_UnasApps_cw[i]), 36) + '</span>';
        str += '</td>';
        str += '<td width="30%" align="center"><span class="unas_table_text">' + UNAS._(appState) + '</span></td>';
        str += '</tr>';
        jQuery('#useraccount_appprivilege_applist').append(str);
      }
      jQuery("#useraccount_appprivilege_applist tr:even").addClass("tr_even");
      jQuery("#useraccount_appprivilege_applist tr:odd").addClass("tr_odd");
      jQuery('#useraccount_appprivilege_applist tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#useraccount_appprivilege_applist tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#useraccount_appprivilege_applist tr:even").addClass("tr_even");
        jQuery('#useraccount_appprivilege_applist tr:odd').addClass("tr_odd");
      });
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function cwcheckUserAccountAppPrivilegeSubmit() {
  if (cwcheckUserAccountAppPrivilegeSubmit_app()) {
    // jQuery('#jv-useraccount_privilege_enter').attr('class', 'unas_button_sub');
  } else {
    // jQuery('#jv-useraccount_privilege_enter').attr('class', 'unas_button_sub_disabled');
  }
}

function cwcheckUserAccountAppPrivilegeSubmit_app() {
  var flag = 0;
  jQuery("input[name='useraccount_app_privilege_ugcheck']").each(function() {
    if (jQuery(this).prop("checked") == false) {
      flag = 1;
      return false;
    } else {
      flag = 0;
    }
  });
  if (flag == 1) {
    jQuery("#useraccount_app_privilege_selectall").prop("checked", false);
  } else {
    jQuery("#useraccount_app_privilege_selectall").prop("checked", true);
  }
  var state = false;
  jQuery("input[name='useraccount_app_privilege_ugcheck']").each(function() {
    if ((jQuery(this).attr('alreadyin') == '0') && (jQuery(this).prop('checked') == true)) {
      state = true;
      return false;
    }
    if ((jQuery(this).attr('alreadyin') == '1') && (jQuery(this).prop('checked') == false)) {
      state = true;
      return false;
    }
  });
  return state;
}

jQuery("#useraccount_app_privilege_selectall").click(function() {
  if (jQuery("#useraccount_app_privilege_selectall").prop("checked")) {
    jQuery("input[name='useraccount_app_privilege_ugcheck']").prop("checked", true);
  } else {
    jQuery("input[name='useraccount_app_privilege_ugcheck']").prop("checked", false);
  }
  cwcheckUserAccountAppPrivilegeSubmit();
});




function setUserAccountAppPrivilegeCw(userName) {
  if (jQuery('#useraccount_privilege_enter').attr('class') == 'unas_button_sub_disabled')
    return false;
  var addAccessApps = '';
  var removeAccessApps = '';
  jQuery("input[name='useraccount_app_privilege_ugcheck']").each(function() {
    if ((jQuery(this).attr('alreadyin') == 0) && (jQuery(this).prop('checked') == true)) {
      addAccessApps += jQuery(this).attr('value');
      addAccessApps += ',';
    }
    if ((jQuery(this).attr('alreadyin') == 1) && (jQuery(this).prop('checked') == false)) {
      removeAccessApps += jQuery(this).attr('value');
      removeAccessApps += ',';
    }
  });
  jQuery.ajax({
    url: "/apps/useraccount/includes/services_useraccount.php",
    type: "POST",
    async: true,
    timeout: 30000,
    data: {
      userName: userName,
      addAccessApps: addAccessApps,
      removeAccessApps: removeAccessApps,
      action: "setuseraccountappprivilege"
    },
    success: function(data) {},
    complete: function() {
      var currentWindow = window.top.UNAS.GetWindow('AddUserWindow');
      currentWindow.ProcessAddUser();
      MUI.closeWindow(parent.document.getElementById('AddUserWindow'));
      accountAddUserHideWaiting();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}
