// alert(UNAS.CurrentLanguage);
function getClientWH() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.min(document.body.clientWidth, document.documentElement.clientWidth);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.max(document.body.clientWidth, document.documentElement.clientWidth);
  }

  return {
    w: clientWidth,
    h: clientHeight
  };
}
var cw_raidList = [{
    "name": "RAID0",
    "flag": "option",
    "prompt": "Two or more hard disks are combined to improve performance and capacity, but there is no fault tolerance protection. Failure of a single hard disk will result in the loss of all data in the array. RAID0 is very useful for non critical systems that require high performance ratios."
  },
  { //raid列表
    "name": "RAID1",
    "flag": "default",
    "prompt": "It is usually executed for two hard disks. The data in the hard disk is mapped to provide fault tolerance protection when the hard disk fails. The read and write performance will be provided, while the write performance will be similar to that of a single hard disk. When a single hard disk fails, it can be maintained without losing data. RAID1 is often used when fault tolerance protection is critical but space and performance are not so important."
  }, {
    "name": "RAID5",
    "flag": "option",
    "prompt": "Provides fault tolerance protection and improves read performance. At least three hard disks are required. RAID5 can maintain operation when a single hard disk is lost. In case of a hard disk failure, the data on the failed hard disk will be reconstructed from the parity extended from the other hard disks. Therefore, when the RAID5 array is in a degraded state, the read and write performance will be affected by verification. RAID5 is ideal when storage space and cost are more important than performance."
  }, {
    "name": "RAID6",
    "flag": "option",
    "prompt": "It is similar to Raid5, but it provides another layer of block extension, which can be maintained in case of failure of two hard disks. At least four hard disks are required. The performance of RAID6 is lower than that of RAID6 because of its additional fault tolerance protection function. RAID6 is the most ideal when storage space and cost are important and multiple hard disks need to fail to maintain."
  }, {
    "name": "RAID10",
    "flag": "option",
    "prompt": "It combines the advantages of RAID1 and RAID0. The read and write performance is improved, but the space used to store data is only average of the total space. The cost of adapting four or more hard disks is relatively high, but the performance is high when providing fault tolerance protection. If it does not occur in the same subgroup, RAID10 can be maintained when multiple hard disks fail. RAID10 is ideal for applications with high input/output requirements."
  }, {
    "name": "JBOD",
    "flag": "option",
    "prompt": "JBOD (Disk Cluster) is a storage device with multiple disk drives installed on a backplane. Unlike RAID arrays, JBOD does not have front-end logic to manage the data distribution on the disk. JBOD is not a standard RAID level"
  }
]


window.configwizardTranslator = null;
var ConfigWizardInfo = {
  easySetupInfo: {
    easysetup_disks: [],
    solname: 1
  }, //一键配置信息
  raidInfo: {}, //raid信息
  homesInfo: {}, //homes信息
  apps: [],
  isconfigdata: 0,
  modeType: ""
};
var prveurl = ''; //记录返回url
var formatres = 1; //是否格式化成功
var uanywhereID = "";

var modeurl = '/apps/configwizard/m/easysetup/easysetup.html?v=6.0.27&'; //保存配置方式
var TIMEOUT = 1200000;
var fy = 0;

var myevent = new CustomEvent("setupNotice",{ detail: {
  formatres : -1
}});

window.formatop = null;

ConfigWizardInfo.raidInfo['vgs'] = {
  // vg1: {
  //   capacity: 3154116608,
  //   free: 0, //33554432,
  //   vg: 'vg1',
  //   lvs: {
  //     fg: {
  //       lv: 'fg',
  //       fstype: "xfs",
  //       capacity: 3154116608,
  //       free: 3087597568,
  //       crypt: 0,
  //       mounted: 1,
  //       size: 56033280,
  //       type: "lv",
  //       vg: "vg1"
  //     },
  //     lv2: {
  //       lv: 'lv2',
  //       fstype: "xfs",
  //       capacity: 3154116608,
  //       free: 3087597568,
  //       crypt: 0,
  //       mounted: 0,
  //       size: 56033280,
  //       type: "lv",
  //       vg: "vg1"
  //     }
  //   }
  // },
  // vg2: {
  //   capacity: 3154116608,
  //   free: 0,
  //   vg: 'vg2',
  //   lvs: {
  //     lv2: {
  //       lv: 'lv2',
  //       fstype: "xfs",
  //       capacity: 3154116608,
  //       free: 3087597568,
  //       crypt: 0,
  //       mounted: 1,
  //       size: 56033280,
  //       type: "lv",
  //       vg: "vg2"
  //     }
  //   }
  // }
}

function cwTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};
// 格式化size
function cwformSize(bytes, decimalPoint) {
  var num = bytes;
  if (typeof(num) !== "number") {
    num = parseInt(num)
  }
  if (num <= 0) return '0 Bytes';
  var k = 1024,
    dm = decimalPoint || 2,
    sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(num) / Math.log(k));
  return parseFloat((num / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function cwgroupCutStr(str, len) {
  if (str == null)
    return '';
  var str_length = 0;
  var str_len = 0;
  str_cut = new String();
  str_len = str.length;
  for (var i = 0; i < str_len; i++) {
    a = str.charAt(i);
    str_length++;
    if (escape(a).length > 4) {
      str_length++;
    }
    str_cut = str_cut.concat(a);
    if (str_length >= len) {
      str_cut = str_cut.concat("...");
      return str_cut;
    }
  }
  if (str_length < len) {
    return str;
  }
}

function loading_cw_show() {
  jQuery('#jv-cw-loading').show();
}

function loading_cw_hide() {
  jQuery('#jv-cw-loading').hide();
}

//确认弹窗
function configwizardAlertWindow(title, text, fn, isck, name) {
  var cwh = getClientWH();
  var w = parseInt(cwh.w * 0.88);
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(title),
    modal: true,
    addClass: 'alertWindow',
    modalOverlayClose: false,
    width: w,
    height: 200,
    contentURL: '/apps/configwizard/m/alert.html?v=6.0.27&text=' + text + '&showcheckbox=' + isck + "&name=" + name
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
  jQuery(alertWindow.windowEl).addClass('modal-t-2').css('height', '230px');
}

function getapps() {

  var req = new Request({ // Use Mootools ajax to get apps
    url: '/api/php/UNASJS.php',
    method: 'POST',
    data: {
      'action': 'GetApps'
    },
    onRequest: function() {},
    onSuccess: function(responseText) {
      if (responseText == null || responseText.length == 0) {} else {
        UNAS.Apps = JSON.parse(responseText);
      }
    },
    onFailure: function() {

    }
  });
  req.send();
}

getapps();


var OnChangeLanguage_configwizard = null;
var pageTranslators_configwizard = [];

UNAS.LoadTranslation('/apps/configwizard/m/languages/Translation');
UNAS.LoadTranslation('/desktop/languages/DefaultTranslation');
UNAS.LoadTranslation('/apps/easysetup/languages/Translation');
UNAS.LoadTranslation('/apps/lvm/languages/Translation');
UNAS.LoadTranslation('/apps/raidmanager/languages/Translation');
UNAS.LoadTranslation('/apps/useraccount/languages/Translation');
UNAS.LoadTranslation('/apps/groupaccount/languages/Translation');
UNAS.LoadTranslation('/apps/shared-folder/languages/Translation');
OnChangeLanguage_configwizard = function(e) {
  for (var i = 0; i < pageTranslators_configwizard.length; i++) {
    var node = pageTranslators_configwizard[i].node;
    var p = pageTranslators_configwizard[i].translateProperty;
    node[p] = window.top.UNAS._(pageTranslators_configwizard[i].originalText);

  }
  jQuery('#jv-nasmknema').text(UNAS._('Config Wizard'));
  document.title = UNAS._('Config Wizard');
  if (e) {

  }

  function configwizardTranslator(id) {
    let rt_c = document.getElementById(id);
    if (!rt_c) {
      return;
    }
    var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
    pageTranslators_configwizard = pageTranslators_configwizard.concat(tmp_pageTranslators);
    OnChangeLanguage_configwizard();
  }
  window.configwizardTranslator = configwizardTranslator;
};
OnChangeLanguage_configwizard();
window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_configwizard);
window.addEventListener("unload", function(e) {
  window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_configwizard);
}, false);


var jsSrc = (navigator.language || navigator.browserLanguage).toLowerCase();
var lan = UNAS.CurrentLanguage;
if (jsSrc != 'zh-cn') {
  lan = 'English';
} else {
  lan = '简体中文';
}

var urlSearchParams = new URLSearchParams(window.location.search);
// 把键值对列表转换为一个对象
if (!Object.fromEntries) {
  Object.fromEntries = entries => {
    var result = {};
    for (var [key, value] of entries) {
      result[key] = value;
    }
    return result;
  };
}
var params = Object.fromEntries(urlSearchParams.entries());

if (params.l) {
  lan = params.l;
} else if (getCookie('login_lang')) {
  lan = unescape(window.atob(getCookie('login_lang')));
}else {
  lan = sessionStorage.getItem('tempLang') || lan;
}

UNAS.CurrentLanguage = lan;

var UToken;
var tokenArr = document.cookie.split("; ");

if (params.t) {
  UToken = params.t;
}else {
  for (var i = 0; i < tokenArr.length; i++) {
    if (tokenArr[i].search("PHPSESSID") !== -1) {
      UToken = tokenArr[i].split("=")[1]
    }
  }
}
