
function getSn() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/apps/systeminfo/includes/systeminfo.php",
      type: "POST",
      async: true,
      dataType: 'json',
      timeout: 20000,
      data: {
        action: "initinfo"
      },
      success: function(data) {
        resolve(data.info_nassn);
        jQuery('#jv-uanywhere-subdomain').val(data.info_nassn);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {},
      complete: function() {}
    });
  })
}

function getuanywherestatus() {

  jQuery.ajax({
    url: "/apps/uanywhere/includes/services_uanywhere.php",
    type: "POST",
    data: {
      "action": "getuanywherestatus"
    },
    dataType: 'json',
    timeout: 60000,
    success: function(data) {

      jQuery('#jv-uanywhere-cn').empty();
      if (data.subdomain) {
        jQuery('#jv-uanywhere-subdomain').val(data.subdomain)
      } else {
        getSn();
      }

      if (!data.domains.length) {
        data.domains = [{
          domain: "myunas.cn"
        }];
      }

      if (data.code == 1) {

        if (data.status == "enable") {
          jQuery('#jv-uaStatus').addClass("open").children(".switch-btn").addClass("right");

          jQuery('#jv-uanywhere-infor').show();
          jQuery('#jv-uanywhere-url').attr("href", "http://" + data.subdomain + '.' + data.domain);
          jQuery('#jv-uanywhere-url').html("http://" + data.subdomain + '.' + data.domain);
          jQuery('#jv-uanywhere-id').html(data.subdomain);

        } else {
          jQuery('#jv-uaStatus').removeClass("open").children(".switch-btn").removeClass("right");
          jQuery('#jv-uanywhere-infor').hide();
        }

        jQuery('#jv-uanywhere-subdomain').val(data.subdomain);

        var i = 0;
        jQuery.each(data.domains, function(key, value) {
          if (data.domain == value.domain) {
            var str = '<option value="' + value.domain + '" selected="true">' + value.domain + '</option>';
            jQuery('#jv-uanywhere-cn').attr("oldvalue", value.domain);
          } else {
            var str = '<option value="' + value.domain + '">' + value.domain + '</option>';
          }
          jQuery('#jv-uanywhere-cn').append(str);
          i = 1;
        });

      } else {
        var i = 0;
        jQuery.each(data.domains, function(key, value) {
          if (data.domain == value.domain) {
            var str = '<option value="' + value.domain + '" selected="true">' + value.domain + '</option>';
            jQuery('#jv-uanywhere-cn').attr("oldvalue", value.domain);
          } else {
            var str = '<option value="' + value.domain + '">' + value.domain + '</option>';
          }
          jQuery('#jv-uanywhere-cn').append(str);
          i = 1;
        });


      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }
  });
}

function setUAnywhere(sw) {
  jQuery('#jv-uaStatus').css('pointer-events', 'none');
  var account = jQuery('#jv-uanywhere-subdomain').val() + '@' + jQuery('#jv-uanywhere-cn').val();
  jQuery.ajax({
    url: "/apps/uanywhere/includes/services_uanywhere.php",
    type: "POST",
    dataType: 'json',
    data: {
      "action": "modifyuanywheregeneralsettings",
      "account": account,
      "enable": sw,
      "subdomain": jQuery('#jv-uanywhere-subdomain').val(),
      "domain": jQuery('#jv-uanywhere-cn').val(),
      "utoken": UToken
    },
    timeout: 60000,
    success: function(data) {
      jQuery('#jv-uaStatus').css('pointer-events', 'auto');
      getuanywherestatus();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }
  });
}

function switchControl(t, callback) {
  jQuery(t).toggleClass("open").children(".switch-btn").toggleClass("right");

  let clickType = jQuery(t).hasClass('open') ? true : false;
  var enable = "disable";
  if (jQuery('#jv-uaStatus').hasClass('open')) {
    enable = "enable";
  } else {
    enable = "disable";
  }

  setUAnywhere(enable);

  if (typeof callback === 'function') {
    callback(clickType);
  }
}


(function() {
  getuanywherestatus();
})()
