//raid选择
function showselectOp() {
  var ev = window.event || arguments.callee.caller.arguments[0];
  ev.stopPropagation();
  jQuery('#jv-selectOp').slideToggle();

  document.onclick = function(e) {
    e.stopPropagation();
    jQuery('#jv-selectOp').slideUp();
  }
}

function getSn() {
  jQuery.ajax({
    url: "/apps/systeminfo/includes/systeminfo.php",
    type: "POST",
    async: true,
    dataType: 'json',
    timeout: 20000,
    data: {
      action: "initinfo"
    },
    success: function(data) {
      jQuery('#jv-snID').val(data.info_nassn);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {},
    complete: function() {}
  });
}

var easySetupApply = function() {
  return new Promise(function(resolve, reject) {
    var solname = ConfigWizardInfo.easySetupInfo.solname;
    let data = {
      cmd: 'easysetup_create',
      token: UToken,
      params: {
        "devices": ConfigWizardInfo.easySetupInfo.easysetup_disks,
        "raid": solname == 'JBOD' ? 'jbod' : parseInt(solname)
      }
    }
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      dataType: 'json',
      data: JSON.encode(data),
      timeout: 1800000,
      success: function(data) {

      },
      complete: function(res) {
        var info = res.responseJSON;
        resolve(info);
        if (info.err == 0) {
          myevent.detail.formatres = 1
          formatres = 1;
        } else {
          myevent.detail.formatres = 0;
          formatres = 0;
        }
        document.dispatchEvent(myevent);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(Object.fromEntries(XMLHttpRequest));
      }
    });
  })

}


function listdisksandsolutions() {
  jQuery.ajax({
    url: "/apps/configwizard/m/includes/services_easysetup.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: {
      "action": "listdisksandsolutions"
    },
    timeout: 300000,
    success: function(data) {
      ConfigWizardInfo.easySetupInfo.easysetup_disks = [];
      if (data) {
        var solutions = data.solutions || [];
        var cw_raidList_easysetup = [];
        var disks = data.disks || [];
        jQuery('#jv-disks-host').empty();
        if (disks.length) {
          jQuery('#jv-next').removeClass('disabledBtn');
        } else {
          jQuery('#jv-next').addClass('disabledBtn');
        }
        for (var h = 0; h < disks.length; h++) {
          var disksdata = disks[h];
          ConfigWizardInfo.easySetupInfo.easysetup_disks.push(disksdata.device);
          var diskdom = cwTemplateAppend('#jv-disks-host', 'jvt-diskitem', 'jvt-diskitem-' + h);
          diskdom.find('.dev').text(disksdata.device);
          diskdom.find('.model').text(disksdata.model);
          diskdom.find('.size').text(disksdata.size);
        }
        if (solutions.length) {
          for (var j = 0; j < solutions.length; j++) {
            for (var k = 0; k < cw_raidList.length; k++) {
              if (cw_raidList[k].name == solutions[j].name) {
                if (solutions[j].flag == 'default') {
                  cw_raidList[k].flag = 'default';
                } else {
                  cw_raidList[k].flag = 'option';
                }
                cw_raidList_easysetup.push(cw_raidList[k]);
              }

            }
          }

          jQuery('#jv-selectOp').html('');
          for (var i = 0; i < cw_raidList_easysetup.length; i++) {
            var cw_raidinfo = cw_raidList_easysetup[i];
            var v = cw_raidinfo.name.match(/\d+(.\d+)?/g) ? cw_raidinfo.name.match(/\d+(.\d+)?/g) : cw_raidinfo.name;
            var mi = document.createElement("li");

            if (cw_raidinfo.flag == 'default') {
              jQuery('#jv-currentOp').text(cw_raidinfo.name + '（recommend）').attr('flag', cw_raidinfo.flag).attr('value', v);
              jQuery('#jv-raidprompt').attr('title', UNAS._(cw_raidinfo.prompt, UNAS.CurrentLanguage));
              ConfigWizardInfo.easySetupInfo.solname = v;
              jQuery(mi).text(cw_raidinfo.name + '（recommend）').attr('flag', cw_raidinfo.flag).data('raiddata', cw_raidinfo);
            } else {
              jQuery(mi).text(cw_raidinfo.name).attr('flag', cw_raidinfo.flag).data('raiddata', cw_raidinfo);
            }

            jQuery(mi).attr('value', v);
            jQuery('#jv-selectOp').append(mi);

            mi.onclick = function(em) {
              em.stopPropagation();
              var raiddata = jQuery(this).data('raiddata');
              if (raiddata.flag == 'default') {
                jQuery('#jv-currentOp').text(raiddata.name + '（recommend）').attr('flag', jQuery(this).attr('flag'));
              } else {
                jQuery('#jv-currentOp').text(raiddata.name).attr('flag', jQuery(this).attr('flag'));
              }
              jQuery('#jv-currentOp').attr('value', jQuery(this).attr('value'));
              jQuery('#jv-raidprompt').attr('title', UNAS._(raiddata.prompt, UNAS.CurrentLanguage));
              ConfigWizardInfo.easySetupInfo.solname = jQuery(this).attr('value');
              jQuery('#jv-selectOp').slideUp();

              configwizardTranslator('jv-currentOp');
            }

          }

          jQuery('#jv-raidprompt').on('mouseenter', function() {
            var title = UNAS._(jQuery(this).attr('title'), 'English');
            jQuery(this).attr('title', UNAS._(title, UNAS.CurrentLanguage));
          })

          configwizardTranslator('jv-select-container');
        }

      }
    },
    complete: function(x) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

var setUAnywhere = function() {
  jQuery.ajax({
    url: "/apps/uanywhere/includes/services_uanywhere.php",
    type: "POST",
    dataType: 'json',
    data: {
      "action": "modifyuanywheregeneralsettings",
      "account": uanywhereID + '@' + 'myunas.cn',
      "enable": 'enable',
      "subdomain": uanywhereID,
      "domain": 'myunas.cn',
      "utoken": UToken
    },
    timeout: 60000,
    success: function(data) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }
  });
}

function enterNext() {
  uanywhereID = jQuery('#jv-snID').val();
  nextStep('/apps/configwizard/m/format/formatstart.html?v=6.0.27&');
  window.formatop = easySetupApply;
  window.setUAnywhere = setUAnywhere;
}

function showPrompt(type) {
  jQuery('#jv-popup').show();
  jQuery('#jv-modal-content').empty().html(jQuery('#jvt-' + type).html());
}

function closepopup() {
  jQuery('#jv-popup').hide();
}
(function() {

})();
