//创建共享文件夹
function createSharedFolder() {
  var sharedFolderinfo = jQuery('#jv-createSharedFolder').data('sharedFolderinfo');
  var vg = sharedFolderinfo.vg;
  var lv = sharedFolderinfo.lv;
  var path = sharedFolderinfo.path;
  var mounpoint = sharedFolderinfo.mountpoint;
  var cwh = getClientWH();
  var CreateSharedFolderW = new MUI.Modal({
    id: 'CreateSharedFolderWindow',
    title: UNAS._('Create Shared Folder'),
    // modal: true,
    type: 'modal2',
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h,
    contentURL: '/apps/configwizard/m/sharedfolder/createsharedfolder.html?v=6.0.27&vg=' + vg + '&lv=' + lv + '&path=' + path + '&mountpoint=' + mounpoint
  });
  CreateSharedFolderW.ProcessCreateSharedFolder = function() {
    getSharedFoldersInfo();
  };
  jQuery(CreateSharedFolderW.windowEl).addClass('modal-t-2');
}

function getSharedFoldersInfo() {

  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "sharedfolder_alload",
      token: UToken
    }),
    dataType: "json",
    contentType: "application/json;charset=utf-8",
    success: function(data) {
      if (data.err == 0) {
        var records = data.results.records || [];
        jQuery('#jv-selectOp').empty();
        if (!records.length) {
          jQuery('#jv-createSharedFolder').addClass('disabledBtn');
          jQuery('.swiper-button-next, .swiper-button-prev').hide();
          jQuery('#jv-mySwiper').hide();
          jQuery('#jv-nofolder').show();
        }
        for (var i = 0; i < records.length; i++) {
          for (var j = 0; j < records[i].lvs.length; j++) {
            var pathdom = cwTemplateAppend('#jv-selectOp', 'jvt-pathitme', 'jvt-pathitme-' + i + j);
            var lvdata = records[i].lvs[j];
            pathdom.text(lvdata.path).data('lvdata', lvdata);
            if (i == 0) {
              jQuery('#jv-currentOp').text(lvdata.path);
              jQuery('#jv-createSharedFolder').data('sharedFolderinfo', lvdata);
              refreshFolderlist(lvdata.folders);
            }
            pathdom.on('click', function(e) {
              e.stopPropagation();
              var currentOp = jQuery('#jv-currentOp').text();
              var currentOplvdata = jQuery(this).data('lvdata');
              jQuery('#jv-currentOp').text(currentOplvdata.path);
              jQuery('#jv-createSharedFolder').data('sharedFolderinfo', currentOplvdata);
              jQuery('#jv-selectOp').slideUp();
              if (currentOplvdata.path != currentOp) {
                refreshFolderlist(currentOplvdata.folders);
              }
            })
          }
        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function refreshFolderlist(folders) {
  jQuery('#jv-folderhost').empty();
  if (folders.length) {
    jQuery('#jv-mySwiper').show();
    jQuery('#jv-nofolder').hide();
  } else {
    jQuery('#jv-mySwiper').hide();
    jQuery('#jv-nofolder').show();
  }
  for (var i = 0; i < folders.length; i++) {
    var folderdata = folders[i];
    var pathdom = cwTemplateAppend('#jv-folderhost', 'jvt-sharedfolderitem', 'jvt-sharedfolderitem-' + i);
    pathdom.data('folderinfo', folderdata);
    pathdom.find('.sharedfoldername').text(folderdata.name);
    pathdom.find('.isshare').text(folderdata.share == 1 ? 'Shared' : 'Unshared').addClass('share-' + folderdata.share);
    // 编辑共享文件夹
    pathdom.find('.editfolder').on('click', function() {
      var c_folderinfo = jQuery(this).closest('div.swiper-slide ').data('folderinfo');
      var sharedFolderinfo = jQuery('#jv-createSharedFolder').data('sharedFolderinfo');
      editSharedFolderWindowFun(c_folderinfo, sharedFolderinfo)
    })
    // 删除共享文件夹
    pathdom.find('.delfolder').on('click', function() {
      var c_folderinfo = jQuery(this).closest('div.swiper-slide ').data('folderinfo');
      var sharedFolderinfo = jQuery('#jv-createSharedFolder').data('sharedFolderinfo');
      deleteSharedFolderWindowFun(c_folderinfo, sharedFolderinfo);
    })

  }


  // var swiper = new Swiper(".mySwiper", {
  //   slidesPerView: 5,
  //   spaceBetween: 20,
  //   slidesPerGroup: 1,
  //   // loop: true,
  //   // loopFillGroupWithBlank: true,
  //   preventLinksPropagation: false,
  //   navigation: {
  //     nextEl: ".swiper-button-next",
  //     prevEl: ".swiper-button-prev",
  //   },
  //   pagination: {
  //     el: '.swiper-pagination',
  //     clickable: true
  //   }
  // });
  setTimeout(function() {
    configwizardTranslator('jv-folderhost');
  }, 100);
}

// 编辑共享文件夹
function editSharedFolderWindowFun(c_folderinfo, sharedFolderinfo) {
  var folder = c_folderinfo.name;
  var vg = sharedFolderinfo.vg;
  var lv = sharedFolderinfo.lv;
  var path = sharedFolderinfo.path;
  var mounpoint = sharedFolderinfo.mountpoint;
  var name_editable = 1;
  if ((typeof(sharedFolderinfo.normal_lv) != "undefined") && (sharedFolderinfo.normal_lv == "0")) {
    name_editable = 0;
  }
  localStorage.setItem('folder', folder);
  var cwh = getClientWH();

  var EditSharedFolderW = new MUI.Modal({
    id: 'EditSharedFolderWindow',
    title: UNAS._('Edit Shared Folder') + " " + cwgroupCutStr(folder, 60),
    // modal: true,
    type: 'modal2',
    modalOverlayClose: false,
    width: cwh.w,
    height: cwh.h,
    contentURL: '/apps/configwizard/m/sharedfolder/editsharedfolder.html?v=6.0.27&path=' + path + '&mountpoint=' + mounpoint + "&folder=" + folder + "&vg=" + vg + "&lv=" + lv + "&name_editable=" + name_editable
  });
  EditSharedFolderW.ProcessEditSharedFolder = function() {
    getSharedFoldersInfo()
  };
  jQuery(EditSharedFolderW.windowEl).addClass('modal-t-2');
}
// 删除共享文件夹
function deleteSharedFolderWindowFun(c_folderinfo, sharedFolderinfo) {
  var folder = c_folderinfo.name;
  var vg = sharedFolderinfo.vg;
  var lv = sharedFolderinfo.lv;
  var cwh = getClientWH();
  var w = parseInt(cwh.w * 0.88);
  var DeleteSharedFolderW = new MUI.Modal({
    id: 'DeleteSharedFolderWindow',
    title: UNAS._('Delete Shared Folder') + " " + folder,
    addClass: 'alertWindow',
    type: 'modal2',
    width: w,
    height: 250,
    contentURL: '/apps/configwizard/m/sharedfolder/deletesharedfolder.html?v=6.0.27&folder=' + folder + '&lvname=' + lv + "&vgname=" + vg
  });
  DeleteSharedFolderW.ProcessDeleteSharedFolder = function() {
    getSharedFoldersInfo();
  };
  jQuery(DeleteSharedFolderW.windowEl).addClass('modal-t-2').css('height', '280px');
}
